/*
----------------------
Be Sample Code License
----------------------

Copyright 1991-2001, Be Incorporated.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions, and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions, and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    
*/
#include "debug.h"

#ifndef _topview
#define _topview

#include <Box.h>
#include <Button.h>
#include <ListView.h>
#include <Looper.h>
#include <Menu.h>
#include <MenuField.h>
#include <MenuItem.h>
#include <MessageFilter.h>
#include <OS.h>
#include <String.h>
#include <View.h>

#define MySharedFiles 'mysf'
#define NetSharedFiles 'ntsf'

struct siteinfo_st {
	BString host;
	BMessage *files;
	siteinfo_st() {
		files=NULL;
		host="Unknown";
	}
	~siteinfo_st() {
		if (files!=NULL)
			delete files;
	}
};

class flstfilter: public BMessageFilter {
	public:
	//Public Variables
		BView *view;

	//Public Functions
		//BMessageFilter Inherited Functions
			flstfilter(BView *vw);

		//Class Specific Functions
			filter_result Filter(BMessage *msg, BHandler **target);
};

class topview: public BView {

	public:
	//Public Variables
		BButton *dload,*remove;
		BListView *lview;
		BBox *box;
		BMenuField *mfield;
		BMenu *menu;
		BLooper *NetCenter;
		siteinfo_st *cur_host;
		sem_id update_sem;
	
	//Public Functions
		//BView Inherited Functions
			topview(BRect frame,const char *name,uint32 resizem,uint32 flags);
			~topview();
			void MessageReceived(BMessage *msg);
			void AllAttached();
};

#endif
